{ }
(*
	ARDisabler V1.0 by Albert Research 99

	Legal Notice:

	Distribution

	This component is freeware. As such, Albert Research gives no warranty to its accuracy, fitness for any particular use, effects of use, or reliability.
	This component may not be distributed as a part of another component package without Albert Research written consent. It may be freely distributed,
	although it must be distributed with all original files in their original format intact. If you use this component in your software, please include an acknow-
	ledgment that portions are copyrighted by Albert Research. Please contact the author, Albert, at one of the below address with questions, comments, bug-reports
	 or any updates you make to the component.

	 Albert Research:

	 e-mail: albertrs@redestb.es
	 Web: http://personal.redest.es/albertrs



								 ``     ```''MM'``
										``A##NNN````
								   `` ``''#UUMMMNN```
								 ``  'MMAAHRRMMMHHNN```
								   ``R@@##@##MMHHHMMN````
								 ``HHR@@@@@##MMMHHNNNNN``
							  ```AAHH#@@@@@@@MMNNNMMMHHNN`           `
				  ``       `````H##@@H####@##MMMMMHHMHHHHH```` ````
						 `` ''###@@##HHHHHR##MMNNNMMNHHHHNNN`````  ``
				  ```      `UU###@@HH@##RR#RRMMMHHNNNNNMMHHHNN`````  `
						 ``#####@##@@@@@##@##MMMMMNNNHHNNNNNNNN````
					   ````RHH##H#####@@@@@##NNNNNMMMNNNNNNNHHHNN  ``
					   `````''~~~::UU@##RR#RRMMMMMNNMMMMM'''```````
					`##HHHH@HH@@HHHHHHHHNNH@@NNHHH@@HHHHH@##HH#@@##HH`
      `````        ````'####@@###@@H@@HHH@@HHHHHHH@HH@@@@@@@@@@NNMNNHHHHH``
		``     ```##@@@@@##@@@##@@@@@@####@##MMMMMMMNMMMMNMMHHMHHNNNNHNN```
		  `  ```''RR#HH@@@@HRR##@@@@@@@@@@@##MMMNNMMNNNNNNHHMMNNNMMHHNNNHH```  `
		  `    `HHAA@####@@@@@@@H@@@@@@@#####MMNNNMMNNNNNMNNHHNMMNNMMHNNNN'       ``
	  ``   ``  ```''~MM####@HH##@@@@@@@@##@##MMNNNMMNNNNNNNNHHMNNNNMM'''`````  `
	 `    ```##HHH@@@HHHHHHHNNHHHHH@@@@@#####MMMMMMMNNNNN@HH@@@HHHH##H##HHRHHHH```
	  ````M##@@@@@@@@@@@@HHHHHHHHHHHHHHHHHHHH@@H@@@@HHHHHHHH@@@HHNNNNMHHMMNNNHHH````
	  ``''#@@@@@HH@@@@@@@@@@@@@@@HHHHHHHHHHHH@@HHHHHH@@HH@HHNNMMMNNNNHMMHHNNNNNNMM```
      ```MMRR@##@@@@@@@@@@@@HHHHH@@@@@@@@@@@@HHHHH@@@NNMNNMMMMMNNNNNMMMMNMMMMHNNNNMNNNN`
      ''~AA##@##@@H@@@@@@@@@@@@@@@@@@@@@@@@@@@##MMMNNMMNNNMMNNNMMMNNNNNNNNNMMNNNMMNNNNNH
      ~~A@@RRRHHHH#@@@@@@@@@@@@@@@@@@@@@@@@###RRMMMNNHHHNNMMNNNNNNMMMMNNHNNNNNMMHHMNNNNN@@
      ``'@@##@RR##H@@@@@@@####@##@@@@@@@@@@###@@MMMMMMMNNNHHNNNNNNNNNNNNNNNMMHNNNNHMMHH```
		  ```''M####@##HH##H@@HH#@@HH@HHHH#@@NNNNNNNNNNNNMMMNNNMMNNMMNHHNNN`````  ``
		   ```````MMRRRRR@@#HH@@@##HHH@@HHRRRMMMNNNNMNNNNNMMNNNMMNNHHHNN`````
      ```    ```       `````''R####A@@###HH@@@##MMNMMNNMNNHHNHHNNN``````     `
		   ``               ```````##R@@@@@@@HHMNNNNHNN```       ``
	  ``                         ``'''MMAA#RRMMNHHMM`````          ``   ``
										   ``''     `

*)
{ }

{V1.0... Initial Release}

unit ARDisabler;

interface

uses
	Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,ExtCtrls,dsgnintf,stdctrls;

type
		TAboutProperty = class(TPropertyEditor)
			public
				procedure Edit; override;
				function GetAttributes: TPropertyAttributes; override;
				function GetValue: string; override;
			end;{TAboutProperty}

		TOffsetValues = class(TPersistent)
			private
				{ Private declarations }
				V_Border_Left: integer;
				V_Border_Right: integer;
				V_Border_Top: integer;
				V_Border_Bottom: integer;
				V_Fill_HorizontalStep: integer;
				V_Fill_VerticalStep: integer;
				procedure PSetV_Border_Right(const Value: integer);
				procedure PSetV_Border_Left(const Value: integer);
				procedure PSetV_Border_Bottom(const Value: integer);
			    procedure PSetV_Border_Top(const Value: integer);
				procedure PSetV_Fill_HorizontalStep(const Value: integer);
				procedure PSetV_Fill_VerticalStep(const Value: integer);
			protected
				{ Protected declarations }			
			public
				{ Public declarations }
				constructor Create;
				destructor Destroy; override;
			published
				{ Published declarations }
				property Border_Left: integer read V_Border_Left write PSetV_Border_Left;
				property Border_Right: integer read V_Border_Right write PSetV_Border_Right;
				property Border_Top: integer read V_Border_Top write PSetV_Border_Top;
				property Border_Bottom: integer read V_Border_Bottom write PSetV_Border_Bottom;
				property Fill_HorizontalStep: integer read V_Fill_HorizontalStep write PSetV_Fill_HorizontalStep;
				property Fill_VerticalStep: integer read V_Fill_VerticalStep write PSetV_Fill_VerticalStep;				
				
		end;{TOffsetValues}

		TARDisabler = class(TComponent)
			private
				{ Private declarations }
				V_About: TAboutProperty;
				V_Image	: TImage;
				V_Panel : TPanel;
				V_MasterControl: TControl;
				V_DisableMaster: boolean;
				V_Active: boolean;
				V_OffsetValues: TOffSetValues;
				V_FillColor: TColor;
				V_OriginalHook: TWndMethod;
				V_LinkToMaster: boolean;
				procedure PSetV_MasterControl(const Value: TControl);
				procedure PSetV_DisableMaster(const Value: boolean);
				procedure PSetV_Active(const Value: boolean);
				procedure MakeDisplay;
				procedure PSetV_LinkToMaster(const Value: boolean);
			protected
				{ Protected declarations }
				procedure Notification(AComponent: TComponent;Operation: TOperation); override;
				procedure Loaded;override;
				procedure MessageHook(var Message: TMessage);

			public
				{ Public declarations }
				constructor Create(AOwner: TComponent); override;
				destructor Destroy;override;
				property Active: boolean read V_Active write PSetV_Active;				
			published
				{ Published declarations }
				property Author: TAboutProperty read V_About write V_About;				
				property MasterControl: TControl read V_MasterControl write PSetV_MasterControl;
				property DisableMaster: boolean read V_DisableMaster write PSetV_DisableMaster;
				property Offsets: TOffsetValues read V_OffSetValues write V_OffSetValues;
				property FillColor: TColor read V_FillColor write V_FillColor;
				property LinkToMaster: boolean read V_LinkToMaster write PSetV_LinkToMaster;
		end;{TARDisabler}

procedure Register;

implementation

const
	V_AlbertResearchHeight			= 050;
	V_AlbertResearchWidth			= 050;
	V_AlbertResearch					: array[1..2500] of DWord = (
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00529C5A,$005A9C63,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00185218,$0052A55A,$00429C4A,$00428C42,$004A8452,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005A945A,$00529C52,$0042A54A,$00319C39,$0042A54A,$004A9452,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00216B21,$00429C42,$00399439,$00429C39,$0039A539,$0039AD39,$0042B542,$00399439,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00428C42,$0042A542,$0039A539,$0042A539,$0042AD42,$0042B539,$0029A529,$00219C21,$0042AD42,$00529C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A8C4A,$0042AD42,$0031A531,$0031AD29,$0031A529,$0031A531,$0031AD31,$0031AD29,$0029AD29,$0039AD39,$00429C42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00398C39,$0039AD39,$0029AD29,$0029AD29,$0031A529,$0031AD31,$0029A529,$0031B531,$0039BD39,$0029A529,$0042A542,$00216B21,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00639452,$00396B31,$000000FF,$000000FF,$00318C39,$0031A539,$0031AD31,$0029AD29,$0031AD31,$0039AD31,$0039AD31,$0039AD31,$0031B531,$0031AD31,$0039A539,$00429C4A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A944A,$004AA54A,$0052A542,$005AA552,$000000FF,$00317339,$00429C42,$00299C31,$0031AD31,$0031AD31,$0031AD31,$0039AD31,$0039A531,$0031AD31,$0031AD31,$0031AD31,$0039AD39,$00429C42,$00215A21,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9C52,$00399C39,$0039AD39,$0042AD42,$00399C39,$000000FF,$00398442,$00429442,$00298C29,$0039A539,$0031A539,$0031AD31,$0031AD31,$0039A531,$0031A531,$0031A531,$0031A531,$0031A531,$00399C39,$00529C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00528452,$004A9C4A,$0039A539,$0031AD39,$0029A529,$0031AD39,$0042A542,$00187318,$00429442,$00398C39,$00399431,$0039A539,$0039A539,$0039AD39,$0031AD31,$0039A539,$0039A539,$0039A539,$0039AD39,$0031AD31,$0039AD42,$004AA552,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00398439,$0042A542,$0031AD31,$0029B531,$0029AD31,$0039AD42,$0039A542,$0042A542,$00319431,$00399431,$00399431,$00399C39,$0039A539,$0031AD31,$0031AD31,$0031AD31,$0039AD39,$0039A539,$0039AD39,$0031AD31,$0029A529,$0042AD4A,$004A944A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A31,$000000FF,$000000FF,$00428C39,$0031A531,$0039B531,$0031B539,$0029AD31,$00299C31,$0039A542,$0039AD42,$00319C29,$00298C29,$00298C29,$00319431,$0031A539,$0029AD31,$0021AD29,$0031AD31,$0039AD31,$0039A539,$0039AD39,$0031B531,$0039B539,$0039A539,$004AA54A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9452,$00529C52,$006BA563,$000000FF,$000000FF,$00428C4A,$0042A542,$0031A531,$0031A531,$00299C29,$0042B54A,$0031A539,$0031AD29,$0029A529,$00299C31,$00319431,$00319431,$0031A539,$0021AD29,$0021B521,$0031B531,$0039AD31,$0039A539,$0039AD39,$0029A529,$0021A521,$0039B539,$00319431,$005A8C52,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$006B946B,$005A945A,$004AA54A,$00319431,$00529C4A,$000000FF,$000000FF,$00398442,$0042A54A,$0039A539,$0039A539,$0042B542,$00299429,$0031AD31,$0029A529,$0031AD31,$00219421,$00299431,$00319431,$0031A539,$0029AD29,$0021B521,$0031B531,$0039B531,$0039A539,$0039AD39,$0031B531,$0031B529,$0029A529,$004AAD39,$00528C4A,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$0042944A,$0042A54A,$0039A542,$0042AD42,$0042AD42,$00429C42,$000000FF,$00186321,$00398C42,$00399442,$0042AD4A,$0039AD39,$0039AD39,$0031AD31,$0031AD31,$0039B539,$0031AD39,$00319C31,$00299431,$00319431,$0031A531,$0039AD31,$0039B531,$0031B531,$0031AD31,$0031AD39,$0031AD39,$0031B539,$0029A529,$0039AD29,$0042A531,$00529442,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00397B42,$004AA552,$0039AD42,$0031AD39,$0031AD31,$0031A531,$00319C31,$0042A54A,$000000FF,$00298431,$00318431,$00318C39,$00399C42,$0031A539,$0031AD31,$0031AD29,$0029AD29,$0031AD31,$0031A531,$00299C31,$00299431,$00299431,$00319C31,$0039A531,$0039AD31,$0031AD31,$0029AD31,$0029AD39,$0029AD39,$0021A529,$0039BD39,$0039AD29,$0039A529,$005AA542,$005A8C52,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005AA552,$004AA542,$0039A539,$0039AD31,$0031B531,$0029A529,$0039B539,$0039AD39,$004AAD4A,$000000FF,$00399C42,$00319439,$00399C42,$0042AD4A,$0031A531,$0031AD31,$0031AD31,$0031AD29,$0031AD31,$0031A531,$00299C31,$00299431,$00299431,$00319431,$0039A531,$0039AD31,$0031AD29,$0029AD31,$0029A531,$0029AD39,$0029AD31,$0031AD31,$0039B529,$0042B529,$00429C31,$004A9442,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00397B42,$00529C4A,$00399C31,$0039A531,$0031A529,$0039B531,$00219C21,$0031AD31,$0031A529,$0039AD39,$00299C29,$0052BD52,$00298C29,$00298C31,$00319431,$0031A539,$0031AD31,$0031AD31,$0031B529,$0031B529,$0031B531,$0031AD31,$0031A531,$00319C31,$00298C31,$00319431,$0031A531,$0039AD31,$0039AD31,$0031AD31,$0029A531,$0029AD39,$0031B539,$0029AD29,$0029AD21,$0039B529,$0042AD31,$004AA542,$004A8C52,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A9C52,$004AAD4A,$0039A531,$0042B539,$0029A529,$0039B531,$0029A521,$0031AD31,$0039B539,$0031AD31,$0042B539,$00299C29,$0031A531,$00299431,$00319C31,$00319C31,$00299C29,$0031AD31,$0031AD29,$0029AD29,$0029AD29,$0031AD31,$0031AD31,$0031A531,$00299C31,$00298C31,$00319439,$00399C31,$0039AD31,$0039AD31,$0039AD31,$0031AD39,$0031AD39,$0029AD31,$0031B531,$0029AD29,$0031AD29,$0039AD31,$0039A539,$004AA552,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00216B29,$00429C42,$0039A539,$0031AD31,$0031AD31,$0031AD31,$0039B539,$0029A529,$0031A531,$0039AD39,$0039AD31,$0039AD31,$0031AD31,$0039A531,$0039AD39,$00299429,$00299429,$0031A531,$00299C29,$0039AD39,$0031AD31,$0031AD29,$0031AD31,$0031AD31,$0039AD39,$0039A539,$00319C31,$00318C39,$00319439,$00319C31,$0039A531,$0042AD31,$0039AD31,$0039AD39,$0031AD39,$0039AD42,$0029A531,$0031AD29,$0039BD39,$0031AD29,$0031A531,$00399C42,$00216B29,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$00529C4A,$0052AD4A,$0031A529,$0039B539,$0029AD31,$0031B539,$0031AD39,$0039AD42,$0039AD42,$00299C31,$0042AD42,$00399C31,$0042AD42,$0031A531,$0039AD39,$0042B542,$00299429,$00219421,$00319C31,$00319C31,$0039AD39,$0039AD31,$0039AD31,$0039AD39,$0039AD39,$0042AD42,$0042AD42,$00399C39,$00319439,$00319439,$00319C31,$00399C29,$0039A531,$0039A531,$0039A539,$0039A542,$0039A542,$00299C31,$0029A529,$0031AD31,$0031AD31,$0039AD42,$0039A542,$0052A55A,$000000FF,$000000FF,
												   $000000FF,$000000FF,$00638C5A,$00528C4A,$0052A542,$00399C29,$004ABD42,$0031A531,$0031AD39,$0031AD39,$00299C39,$00299C39,$0039A542,$0042A54A,$0042A542,$0042A542,$00399C39,$0039A539,$0042A542,$0042AD42,$00319C31,$00299429,$00299429,$00319C31,$0039A539,$0039A539,$0039A539,$0039A539,$0039A539,$0042A542,$0042A542,$00399C39,$00319439,$00319439,$00319431,$00319C29,$00399C31,$0042A531,$0042A542,$0042A542,$0042A54A,$0039A542,$0042B54A,$00299C31,$0039A539,$0039A539,$0039A539,$004A944A,$000000FF,$000000FF,
												   $000000FF,$0052844A,$00528C4A,$0063A55A,$00429442,$0052A552,$00399439,$0042A54A,$0039A542,$0039A542,$00399C42,$00429C42,$00429C4A,$00429C42,$004AA54A,$004AA54A,$00429C42,$004AA54A,$0042A542,$004AAD4A,$0042A542,$00399C39,$00319431,$00319439,$0042A542,$00429C42,$00429C42,$0042A54A,$00429C4A,$004AA54A,$004AA54A,$0042A54A,$00298C31,$00298C31,$00399C39,$00319429,$004AA539,$00429C39,$004AA54A,$00429442,$00429C4A,$00399442,$004AA54A,$00429C42,$0042A542,$0042A542,$00399C42,$00529C52,$00528452,$000000FF,
												   $00316B21,$00397331,$00317331,$00215A21,$00297331,$00216B29,$00217329,$00186B21,$00217329,$00187321,$00217321,$00217B21,$00297B29,$00217318,$00106310,$00217321,$00217329,$00297329,$00187321,$00187318,$00217321,$00298429,$00318C31,$00399439,$00217321,$00187321,$00217321,$00217329,$00217321,$00217321,$00217321,$00217321,$00399C42,$00319C39,$00319431,$00318C29,$00217B18,$00217318,$00217321,$00297329,$00216B29,$00297B31,$00217329,$00186B21,$00217321,$00186318,$00317B31,$00216321,$00426B42,$000000FF,
												   $000000FF,$00295A29,$00316331,$00296331,$00396B42,$00296331,$00296331,$00317339,$00216321,$00296B21,$00317B29,$00216B18,$00216B21,$00297329,$00216B21,$00296B29,$00296B29,$00297331,$00216B29,$00216B21,$00297B29,$00398C39,$00429442,$00398C39,$00216B21,$00216B21,$00296B29,$00296B31,$00296B29,$00216B29,$00216B21,$00217321,$00319439,$00299431,$00298C29,$00399439,$00217318,$00216B21,$00216321,$00296B29,$00296329,$00317331,$00216321,$00296B29,$00296B31,$00296B29,$00296329,$00316331,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$00315A39,$00395A42,$00426B4A,$00315A31,$00396B39,$00396B39,$00397331,$00397329,$00296B21,$00216321,$00317329,$00397B31,$00296B29,$00296329,$00316B31,$00296B31,$00216B21,$00318431,$00398C39,$00398C39,$00318431,$00296B29,$00296B31,$00296B31,$00316B39,$00316B31,$00296B29,$00296B29,$00297B29,$00399439,$00319431,$00318C31,$00429442,$00297329,$00317331,$00316B31,$00296329,$00316B31,$00316B31,$00316B31,$00316B31,$00295A29,$00316331,$00396339,$004A6B4A,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$00395A42,$00395A39,$00426339,$00315A29,$00396331,$00316329,$00296321,$00397339,$00396B31,$00215A21,$00316B31,$00316B31,$00316339,$00316331,$00316B31,$00296B29,$00428C39,$00428C39,$00429442,$00428C42,$00216B29,$00296B29,$00296331,$00296331,$00296331,$00216329,$00296B29,$00317B31,$00429C39,$00399431,$00429439,$00297329,$00296329,$00296329,$00396B39,$00296329,$00396B31,$00316331,$00316331,$00316331,$00396331,$00315A31,$00395A39,$00315239,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A39,$00395A31,$00426339,$00426B39,$00315A29,$00295A29,$00396B39,$00316B31,$00316331,$00316331,$00316339,$00295A29,$00316B31,$00296B21,$00428C42,$00398C39,$00428C39,$00398439,$00296B31,$00316B39,$00316B39,$00316339,$00316B31,$00296B29,$00317331,$00428C39,$00399431,$00399431,$00429442,$00296B29,$00316331,$00295A31,$00426B42,$00316331,$00316331,$00316B31,$00316329,$00396331,$00315A31,$004A6B4A,$00426342,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A39,$00295231,$00426B4A,$00396B42,$00316339,$00396B39,$00316339,$00427342,$00396339,$00316331,$00397339,$00296B29,$004A9442,$00398C39,$00398C39,$00297321,$00296B29,$00316B31,$00296331,$00316331,$00316331,$00296329,$00317329,$00428C39,$00399431,$00429439,$00428C42,$00317339,$00316B39,$00316339,$00316339,$00396339,$00295A29,$00316329,$00316329,$00427339,$00315A31,$00395A39,$00395A42,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00315239,$00396342,$00315A39,$00426B42,$00295A29,$00396339,$00396339,$00316331,$00396B31,$00215A18,$00428C42,$00428C39,$00428C39,$00216B21,$00296B29,$00316B31,$00316331,$00316331,$00316B31,$00296B29,$00317B29,$00429442,$00398C31,$00428C39,$00216B21,$00296329,$00295A31,$00396342,$00315A31,$00396B39,$00396B31,$00316B31,$00316B31,$00295A29,$00426342,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00395A42,$00395A42,$00396342,$00316339,$00316331,$00316331,$00397339,$000000FF,$00397B42,$00428442,$004A8C42,$00296B21,$00317329,$00316B31,$00316B31,$00296331,$00296B31,$00297329,$00398C39,$00429439,$00398C39,$00429442,$00296B29,$00296329,$00316B39,$00316331,$00316331,$00316B31,$00316B31,$00296329,$00396B39,$00315A31,$00395A39,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$0042634A,$00395A42,$00426342,$00395A39,$00396331,$00396B31,$00316331,$000000FF,$004A8452,$00528C4A,$00428442,$00316B29,$00316B29,$00397B39,$00296329,$00316B31,$00296B31,$00297329,$00318431,$00429442,$00398C39,$00398439,$00296B29,$00296B29,$00316B31,$00316331,$00316B31,$00316B31,$00296329,$00296331,$00296331,$00396B39,$00426342,$00425239,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A42,$00426342,$00396339,$00426B39,$00315A31,$000000FF,$000000FF,$00427342,$00316B31,$00316B29,$00397331,$00296B29,$00296329,$00317339,$00317B31,$00216B21,$00429439,$00398C39,$00428C42,$00297329,$00296B29,$00316B31,$00296329,$00316B31,$00396B39,$00316B31,$00316B39,$00316B31,$00396B39,$00396339,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00395A39,$00426342,$00395A39,$000000FF,$000000FF,$00528452,$00316329,$00316B31,$00316329,$00316B29,$00296329,$00296B31,$00216B29,$00398C42,$00429442,$00298429,$00428C42,$00216B21,$00316B31,$00316B31,$00296329,$00396B39,$00316B31,$00316B31,$00316331,$00316B31,$00316339,$00396339,$00395A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395239,$004A634A,$000000FF,$000000FF,$004A7B52,$00396339,$00316B31,$00396B31,$00316B31,$00316B39,$00185A21,$00317331,$00398C42,$00398C31,$00429C42,$00398439,$00296B29,$00296B29,$00296B29,$00316B31,$00316B31,$00296329,$00316B31,$00397339,$00316331,$00315A31,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$005A7B5A,$00426339,$00396331,$00396B31,$00296329,$00397339,$00316B31,$00297331,$00398C42,$00398C39,$00398C39,$00317331,$00296B29,$00296B29,$00296329,$00316B31,$00316331,$00295A29,$00316331,$00316331,$00396339,$00315A39,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00426339,$00426339,$00396331,$00427342,$00215A29,$00296331,$00216329,$004A9452,$00429C42,$00318431,$00296B29,$00317331,$00296329,$00316329,$00316B31,$00296329,$00316331,$00316331,$00396B39,$00315A31,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00426339,$004A6B42,$00396339,$00396339,$00397342,$000000FF,$00398442,$00398C39,$00428C42,$00296B29,$00397331,$00316329,$00316B31,$00316B31,$00296329,$00396B39,$00316331,$00316339,$00396339,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A39,$00395A31,$00426342,$00396339,$000000FF,$00428442,$004A944A,$00398431,$00397331,$00316329,$00316B31,$00316329,$00316B31,$00316331,$00396B39,$00396B39,$00396342,$00426342,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A6B4A,$00425A42,$00395A39,$000000FF,$00316331,$00397B39,$00317331,$00296329,$00396B39,$00396B39,$00295A29,$00296329,$00316B31,$00396B39,$00315A31,$00426342,$00395A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00394A39,$000000FF,$000000FF,$000000FF,$005A8C52,$00316329,$00316331,$00396339,$00316331,$00396B39,$00316331,$00316331,$00316339,$00396B42,$00396339,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426B42,$00396331,$00426339,$00396339,$00295A29,$00396B39,$00396B39,$00396B39,$00316331,$00396339,$00395A39,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00425A42,$00426342,$00426342,$00395A39,$00396339,$00396B39,$00296329,$00316B39,$00396B39,$00396339,$00425A42,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00426342,$00395A39,$00427342,$00315A31,$00316B39,$00316331,$00295A29,$00426B42,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00315231,$00395A39,$00316331,$00316331,$00295A29,$00396B39,$00315A31,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00395A39,$00315A39,$00396B42,$00315A39,$00426342,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$004A634A,$00425A42,$00395239,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,
												   $000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$00526352,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF,$000000FF);

procedure Register;
begin
	RegisterComponents('Albert Research', [TARDisabler]);
	RegisterPropertyEditor(TypeInfo(TAboutProperty), TARDisabler, 'Author', TAboutProperty);	
end;

{ TARDisabler }

constructor TARDisabler.Create(AOwner: TComponent);
begin
	inherited Create(AOWner);

	{Offsets}
	V_OffSetValues := TOffsetValues.Create;

	{Master Control}
	V_MasterControl := nil;

	{Image}
	V_Image := nil;
	{Panel}
	V_Panel := nil;
	

	{Self}
	V_Active := False;
	V_FillColor := clBtnShadow;
	V_LinkToMaster := True;
	V_DisableMaster := False;

	{Offsets}
	V_OffsetValues.Border_Left := 2;
	V_OffSetValues.Border_Right := 2;
	V_OffsetValues.Border_Top := 2;
	V_OffsetValues.Border_Bottom := 2;
	V_OffsetValues.Fill_HorizontalStep := 4;
	V_OffsetValues.Fill_VerticalStep := 2;
	
end;{Create}

destructor TARDisabler.Destroy;
begin
	if not (csDesigning in ComponentState) then
		begin
			{if we Linked to Master}
			if V_LinkToMaster then
				begin
					{If masterControl is not nil}
					if V_MasterControl <> nil then
						begin
							V_MasterControl.WindowProc := V_OriginalHook;
						end;{V_MasterControl <> nil}
				end;{V_LinkToMaster = True}
		end;{Not Designing}

	{Offsets}
	V_OffsetValues.Free;

	inherited Destroy;
end;{Destroy}

procedure TARDisabler.Loaded;
begin
	inherited;

	if not (csDesigning in ComponentState) then
		begin
			{Hook de Messages of MasterControl}
			if V_MasterControl <> nil then
				begin
					if V_LinkToMaster then
						begin
							V_OriginalHook := V_MasterControl.WindowProc;
							V_MasterControl.WindowProc := MessageHook;
						end;{V_LinkToMaster = True}
				end;{V_Mastercontrol <> nil}
		end;{not Desgining}
end;{Loaded}

procedure TARDisabler.MakeDisplay;
var
	V_X						: integer;
	V_Y						: integer;

	V_Position				: TPoint;
	V_Parent				: TComponent;
	V_MasterForm			: TForm;	
begin
	{First We Control if All settings are correct}
	if (V_MasterControl = nil) then
		begin
			exit;
		end;{V_MasterControl = nil}

	{Calc Position}
	V_Position.X := 0;
	V_Position.Y := 0;

	V_Parent := V_MasterControl;
	repeat
		V_Position.X := V_Position.X + TControl(V_Parent).Left;
		V_Position.Y := V_Position.Y + TControl(V_Parent).Top;
		V_Parent := V_Parent.GetParentComponent;
		if V_Parent is TForm then
			begin
				{Asign MasterForm}
				V_MasterForm := TForm(V_Parent);
			end;{V_Parent is TForm}
	until (V_Parent = nil) OR (V_Parent is TForm);

	{if MasterForm is not charged the exit}
	if V_MasterForm = nil then
		begin
			exit;
		end;{V_MasterForm = nil}
		
	{Panel}
	V_Panel := TPanel.Create(V_MasterForm);
	V_Panel.BevelInner := bvNone;
	V_Panel.BevelOuter := bvNone;
	V_Panel.BorderStyle := bsNone;
	V_Panel.Visible := False;
	V_Panel.Parent := V_MasterForm;

	{Image}
	V_Image := TImage.Create(V_Panel);
	V_Image.Parent := V_Panel;
	V_Image.Align := alClient;


	{Adjust Settings}
	V_Panel.Width := V_MasterControl.Width;
	V_Panel.Height := V_MasterControl.Height;
	V_Image.Width := V_MasterControl.Width;
	V_Image.Height := V_MasterControl.Height;



	{Copy the Form Canvas to the Image}
	BitBlt(V_Image.Canvas.Handle,0,0,V_MasterControl.Width,V_MasterControl.Height,V_MasterForm.Canvas.Handle,V_Position.X,V_Position.Y,SRCCOPY);
	{Modify the Image to Look Like a Disabled Panel}
	V_X := V_OffsetValues.Border_Left;
	repeat
		V_Y := V_OffsetValues.Border_Top;
		repeat
			V_Image.Canvas.Pixels[V_X,V_Y] := V_FillColor;
			{Increment}
			inc(V_Y,V_OffsetValues.Fill_VerticalStep);
		until V_Y >= V_Image.Height - V_OffsetValues.V_Border_Bottom;

		{Increment}
		inc(V_X,V_OffsetValues.Fill_HorizontalStep);
	until V_X >= V_Image.Width - V_OffsetValues.Border_Right;

	{Disable Master if Set}
	if (V_DisableMaster) AND (not V_LinkToMaster) then
		begin
			V_MasterControl.Enabled := False;
		end;{V_DisableMaster = True}


	{Adjust Settings}
	V_Panel.Top := V_Position.Y;
	V_Panel.Left := V_Position.X;
	V_Panel.Visible := True;
	V_Panel.BringToFront;
	

end;{MakeDisplay}

procedure TARDisabler.MessageHook(var Message: TMessage);
begin
	{If we are linked then deliver the original message}
	if V_LinkToMaster then
		begin
			V_OriginalHook(Message);
		end;{V_LinkToMaster = True}
		
	{If Message is EnabledChanged then Control}
	if Message.Msg = CM_ENABLEDCHANGED then
		begin
			{If set that we should Stick on the Master}
			if V_LinkToMaster then
				begin
					if V_MasterControl.Enabled then
						begin
							Active := False;
						end{Enabled = True}
					else
						begin
							Active := True;
						end;{Enabled = False}
				end;{V_LinkToMaster = True}
		end;{Msg = CM_ENABLEDCHANGED}
end;{MessageHook}

procedure TARDisabler.Notification(AComponent: TComponent;Operation: TOperation);
begin
	inherited Notification(AComponent, Operation);

	if (Operation = opRemove) and (AComponent = V_MasterControl) then
		begin
			V_MasterControl := nil;
		end;{Romoval of the MasterControl}
end;{Notification}

procedure TARDisabler.PSetV_Active(const Value: boolean);
begin
	if V_Active <> Value then
		begin
			V_Active := Value;

			if V_Active = True then
				begin
					{If Active then Construct de Display}
					MakeDisplay;
				end{V_Active = True}
			else
				begin
					{Enable Master if Set}
					if (V_DisableMaster) AND (not V_LinkToMaster) then
						begin
							V_MasterControl.Enabled := True;
						end;{V_DisableMaster = True}

					{Free}
					V_Image.Free;
					V_Panel.Free;
				end;{V_Active = False}
		end;{V_Active <> Value}
end;{PSetV_Active}

procedure TARDisabler.PSetV_DisableMaster(const Value: boolean);
begin
	if Value <> V_DisableMaster then
		begin
			V_DisableMaster := Value;
		end;{Value <> V_DisableMaster}
end;{PsetV_DisableMaster}

procedure TARDisabler.PSetV_LinkToMaster(const Value: boolean);
begin
	if V_LinkToMaster <> Value then
		begin
			V_LinkToMaster := Value;
		end;{V_LinkToMaster <> Value}

end;{PSetV_LinkToMaster}

procedure TARDisabler.PSetV_MasterControl(const Value: TControl);
begin
	if Value <> V_MasterControl then
		begin
			{Asign de Master Control}
			V_MasterControl := Value;
		end;{Value <> V_MasterControl}
end;{PSetV_MasterControl}



{ TOffsetValues }

constructor TOffsetValues.Create;
begin
	inherited Create;
end;{Create}

destructor TOffsetValues.Destroy;
begin
	inherited Destroy;
end;{Destroy}

procedure TOffsetValues.PSetV_Border_Right(const Value: integer);
begin
	if Value <> V_Border_Right then
		begin
			V_Border_Right := Value;
		end;{Value <> V_Border_Right}
end;{PsetV_Border_Right}

procedure TOffsetValues.PSetV_Border_Left(const Value: integer);
begin
	if Value <> V_Border_Left then
		begin
			V_Border_Left := Value;
		end;{Value <> V_Border_Left}
end;{PsetV_Border_Left}

procedure TOffsetValues.PSetV_Border_Bottom(const Value: integer);
begin
	if Value <> V_Border_Bottom then
		begin
			V_Border_Bottom := Value;
		end;{Value <> V_Border_Bottom}
end;{PsetV_Border_Bottom}

procedure TOffsetValues.PSetV_Border_Top(const Value: integer);
begin
	if Value <> V_Border_Top then
		begin
			V_Border_Top := Value;
		end;{Value <> V_Border_Top}
end;{PsetV_Border_Top}

procedure TOffsetValues.PSetV_Fill_HorizontalStep(const Value: integer);
begin
	if Value <> V_Fill_HorizontalStep then
		begin
			V_Fill_HorizontalStep := Value;
		end;{Value <> V_Fill_HorizontalStep }
end;{PsetV_Fill_HorizontalStep}

procedure TOffsetValues.PSetV_Fill_VerticalStep(const Value: integer);
begin
	if Value <> V_Fill_VerticalStep then
		begin
			V_Fill_VerticalStep := Value;
		end;{Value <> V_Fill_VerticalStep }
end;{PsetV_Fill_VerticalStep}

procedure TAboutProperty.Edit;
var
	VForm				: TForm;
	VButton				: TButton;
	VLabel				: TLabel;
	VLabel1				: TLabel;
	VLabel2				: TLabel;
	VImage				: TImage;

	Counter				: integer;
	x,y					: integer;
begin
	VForm := TForm.Create(nil);
	VButton := TButton.Create(VForm);
	VLabel := TLabel.Create(VForm);
	VLabel1 := TLabel.Create(VForm);
	VLabel2 := TLabel.Create(VForm);
	VImage := TImage.Create(VForm);

	VButton.Width := 60;
	VButton.Height := 21;
	VButton.Left := 126;
	VButton.Top := 120;
	VButton.Caption := 'Ok';
	VButton.ModalResult := mrOk;
	Vbutton.Parent := VForm;

	VLabel.Width := 252;
	VLabel.Height := 205;
	VLabel.Left := 64;
	VLabel.Top := 4;
	VLabel.AutoSize := False;
	VLabel.Caption := 'ARDisabler. A Special Panel to Show as Disa-'+#10
					 +'bled any Control.'+#10+#10#10+'E-Mail:'+#10#10+'WWW:';
	VLabel1.Left := 100;
	VLabel1.Top := 56;

	VLabel2.Left := 100;
	VLabel2.Top := 82;

	VLabel1.Caption := 'albertrs@redestb.es';

	VLabel2.Caption := 'http://personal.redestb.es/albertrs';


	VLabel.Parent := VForm;
	VLabel1.Parent := VForm;
	VLabel2.Parent := VForm;
	VImage.Parent := VForm;
	VImage.Transparent := True;

	VImage.Top := 10;
	VImage.Left := 10;


	Counter := 1;
	VImage.Picture.BitMap.Height := V_AlbertResearchHeight;
	VImage.Picture.BitMap.Width := V_AlbertResearchWidth;	

	for x := 0 to VImage.Picture.BitMap.Width - 1 do
		begin
			for y := 0 to VImage.Picture.BitMap.Height - 1 do
				begin
					VImage.Picture.BitMap.Canvas.Pixels[x,y] := V_AlbertResearch[Counter];
					inc(Counter);
				end;
		end;


	VForm.BorderStyle := bsToolWindow;
	VForm.Width := 324;
	VForm.Height := 170;
	VForm.Position := poScreenCenter;
	VForm.Caption := 'Albert Research 99 ARDisabler V1.0';
	VForm.ShowModal;

end;{Edit}

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
	Result := [paDialog, paReadOnly];
end;{GetAttributes}

function TAboutProperty.GetValue: string;
begin
	Result := 'Albert Research 99';
end;{GetValue}



end.
